/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#include <nepomuk/tools.h>
#include <nepomuk/variant.h>
#include <nepomuk/resourcemanager.h>
#include "bookmark.h"

#include "bookmarkfolder.h"

#include <QtCore/QDateTime>
#include <QtCore/QDate>
#include <QtCore/QTime>


Nepomuk::Bookmark::Bookmark()
  : Resource( QUrl(), QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#Bookmark") )
{
}


Nepomuk::Bookmark::Bookmark( ResourceManager* manager )
  : Resource( QUrl(), QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#Bookmark"), manager )
{
}


Nepomuk::Bookmark::Bookmark( const Bookmark& res )
  : Resource( res )
{
}


Nepomuk::Bookmark::Bookmark( const Nepomuk::Resource& res )
  : Resource( res )
{
}


Nepomuk::Bookmark::Bookmark( const QString& uri )
  : Resource( uri, QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#Bookmark") )
{
}

Nepomuk::Bookmark::Bookmark( const QString& uri, ResourceManager* manager )
  : Resource( uri, QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#Bookmark"), manager )
{
}

Nepomuk::Bookmark::Bookmark( const QUrl& uri )
  : Resource( uri, QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#Bookmark") )
{
}

Nepomuk::Bookmark::Bookmark( const QUrl& uri, ResourceManager* manager )
  : Resource( uri, QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#Bookmark"), manager )
{
}

Nepomuk::Bookmark::Bookmark( const QString& uri, const QUrl& type )
  : Resource( uri, type )
{
}

Nepomuk::Bookmark::Bookmark( const QString& uri, const QUrl& type, ResourceManager* manager )
  : Resource( uri, type, manager )
{
}

Nepomuk::Bookmark::Bookmark( const QUrl& uri, const QUrl& type )
  : Resource( uri, type )
{
}

Nepomuk::Bookmark::Bookmark( const QUrl& uri, const QUrl& type, ResourceManager* manager )
  : Resource( uri, type, manager )
{
}

Nepomuk::Bookmark::~Bookmark()
{
}

Nepomuk::Bookmark& Nepomuk::Bookmark::operator=( const Bookmark& res )
{
    Resource::operator=( res );
    return *this;
}

QString Nepomuk::Bookmark::resourceTypeUri()
{
    return QLatin1String("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#Bookmark");
}

QList<Nepomuk::Resource> Nepomuk::Bookmark::bookmarkses() const
{
    // We always store all Resource types as plain Resource objects.
    // It does not introduce any overhead (due to the implicit sharing of
    // the data and has the advantage that we can mix setProperty calls
    // with the special Resource subclass methods.
    // More importantly Resource loads the data as Resource objects anyway.
    return convertResourceList<Resource>( property( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#bookmarks") ).toResourceList() );
}

void Nepomuk::Bookmark::setBookmarkses( const QList<Nepomuk::Resource>& value )
{
    setProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#bookmarks"), Variant( value ) );
}

void Nepomuk::Bookmark::addBookmarks( const Nepomuk::Resource& value )
{
    // We always store all Resource types as plain Resource objects.
    // It does not introduce any overhead (due to the implicit sharing of
    // the data and has the advantage that we can mix setProperty calls
    // with the special Resource subclass methods.
    // More importantly Resource loads the data as Resource objects anyway.
    Variant v = property( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#bookmarks") );
    v.append( Resource( value ) );
    setProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#bookmarks"), v );
}

Nepomuk::Resource Nepomuk::Bookmark::bookmarks() const
{
    // We always store all Resource types as plain Resource objects.
    // It does not introduce any overhead (due to the implicit sharing of
    // the data and has the advantage that we can mix setProperty calls
    // with the special Resource subclass methods.
    // More importantly Resource loads the data as Resource objects anyway.
    return Resource( property( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#bookmarks") ).toResource().resourceUri() );
}

void Nepomuk::Bookmark::setBookmarks( const Nepomuk::Resource& value )
{
    setProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#bookmarks"), Variant( value ) );
}

QUrl Nepomuk::Bookmark::bookmarksUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#bookmarks");
}

QList<qint64> Nepomuk::Bookmark::characterPositions() const
{
    return ( property( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#characterPosition") ).toInt64List());
}

void Nepomuk::Bookmark::setCharacterPositions( const QList<qint64>& value )
{
    setProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#characterPosition"), Variant( value ) );
}

void Nepomuk::Bookmark::addCharacterPosition( const qint64& value )
{
    Variant v = property( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#characterPosition") );
    v.append( value );
    setProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#characterPosition"), v );
}

qint64 Nepomuk::Bookmark::characterPosition() const
{
    return ( property( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#characterPosition") ).toInt64List() << 0 ).first();
}

void Nepomuk::Bookmark::setCharacterPosition( const qint64& value )
{
    setProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#characterPosition"), Variant( value ) );
}

QUrl Nepomuk::Bookmark::characterPositionUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#characterPosition");
}

QList<qint64> Nepomuk::Bookmark::pageNumbers() const
{
    return ( property( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#pageNumber") ).toInt64List());
}

void Nepomuk::Bookmark::setPageNumbers( const QList<qint64>& value )
{
    setProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#pageNumber"), Variant( value ) );
}

void Nepomuk::Bookmark::addPageNumber( const qint64& value )
{
    Variant v = property( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#pageNumber") );
    v.append( value );
    setProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#pageNumber"), v );
}

qint64 Nepomuk::Bookmark::pageNumber() const
{
    return ( property( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#pageNumber") ).toInt64List() << 0 ).first();
}

void Nepomuk::Bookmark::setPageNumber( const qint64& value )
{
    setProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#pageNumber"), Variant( value ) );
}

QUrl Nepomuk::Bookmark::pageNumberUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#pageNumber");
}

QList<qint64> Nepomuk::Bookmark::streamPositions() const
{
    return ( property( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#streamPosition") ).toInt64List());
}

void Nepomuk::Bookmark::setStreamPositions( const QList<qint64>& value )
{
    setProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#streamPosition"), Variant( value ) );
}

void Nepomuk::Bookmark::addStreamPosition( const qint64& value )
{
    Variant v = property( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#streamPosition") );
    v.append( value );
    setProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#streamPosition"), v );
}

qint64 Nepomuk::Bookmark::streamPosition() const
{
    return ( property( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#streamPosition") ).toInt64List() << 0 ).first();
}

void Nepomuk::Bookmark::setStreamPosition( const qint64& value )
{
    setProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#streamPosition"), Variant( value ) );
}

QUrl Nepomuk::Bookmark::streamPositionUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#streamPosition");
}

QList<Nepomuk::BookmarkFolder> Nepomuk::Bookmark::containsBookmarkOf() const
{
    return convertResourceList<BookmarkFolder>( manager()->allResourcesWithProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#containsBookmark"), *this ) );
}

QList<Nepomuk::Bookmark> Nepomuk::Bookmark::allBookmarks()
{
    return Nepomuk::convertResourceList<Bookmark>( ResourceManager::instance()->allResourcesOfType( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nfo#Bookmark") ) );
}


